Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Kodak.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Kodak.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Kodak.pm	(revision 34921)
@@ -9,4 +9,6 @@
 #               2) http://www.ozhiker.com/electronics/pjmt/jpeg_info/meta.html
 #               3) http://www.cybercom.net/~dcoffin/dcraw/
+#               4) Jim McGarvey private communication
+#               IB) Iliah Borg private communication (LibRaw)
 #
 # Notes:        There really isn't much public information about Kodak formats.
@@ -21,10 +23,12 @@
 use strict;
 use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::Exif;
 
-$VERSION = '1.27';
+$VERSION = '1.47';
 
 sub ProcessKodakIFD($$$);
 sub ProcessKodakText($$$);
+sub ProcessPose($$$);
 sub WriteKodakIFD($$$);
 
@@ -188,4 +192,5 @@
             2 => 'Tungsten',
             3 => 'Daylight',
+            # 5 - seen this for "Auto" with a ProBack 645M
         },
     },
@@ -371,4 +376,6 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
     NOTES => q{
         These tags are used by the CX4200, CX4210, CX4230, CX4300, CX4310, CX6200
@@ -438,4 +445,6 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
     NOTES => 'These tags are used by the DX3215 and DX3700.',
     WRITABLE => 1,
@@ -749,9 +758,17 @@
         Notes => 'Kodak only',
     },
-    0xa8 => { # (not confirmed)
-        Name => 'SerialNumber',
-        Condition => '$$self{Make} =~ /Kodak/i',
+    0xa8 => {
+        Name => 'UnknownNumber', # (was SerialNumber, but not unique for all cameras. eg. C1013)
+        Condition => '$$self{Make} =~ /Kodak/i and $$valPt =~ /^([A-Z0-9]{1,11}\0|[A-Z0-9]{12})/i',
         Format => 'string[12]',
         Notes => 'Kodak only',
+        Writable => 0,
+    },
+    0xc4 => {
+        Name => 'UnknownNumber', # (confirmed NOT to be serial number for Easyshare Mini - PH)
+        Condition => '$$self{Make} =~ /Kodak/i and $$valPt =~ /^([A-Z0-9]{1,11}\0|[A-Z0-9]{12})/i',
+        Format => 'string[12]',
+        Notes => 'Kodak only',
+        Writable => 0,
     },
 );
@@ -772,4 +789,6 @@
         Writable => 'int16u',
         Count => 2,
+        PrintConv => '$val =~ tr/ /x/; $val',
+        PrintConvInv => '$val =~ tr/x/ /; $val',
     },
     # 0x03 int32u - ranges from about 33940 to 40680
@@ -837,4 +856,38 @@
 );
 
+# Kodak PixPro S-1 maker notes (ref PH)
+# (similar to Ricoh::Type2 and GE::Main)
+%Image::ExifTool::Kodak::Type11 = (
+    # (can't currently write these)
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES =>q{
+        These tags are found in models such as the PixPro S-1.  They are not
+        writable because the inconsistency of Kodak maker notes is beginning to get
+        on my nerves.
+    },
+    # (these are related to the Kodak QuickTime UserData tags)
+    0x0104 => 'FirmwareVersion',
+    0x0203 => {
+        Name => 'PictureEffect',
+        PrintConv => {
+            0 => 'None',
+            3 => 'Monochrome',
+            9 => 'Kodachrome',
+        },
+    },
+    # 0x0204 - ExposureComp or FlashExposureComp maybe?
+    0x0207 => 'KodakModel',
+    0x0300 => 'KodakMake',
+    0x0308 => 'LensSerialNumber',
+    0x0309 => 'LensModel',
+    0x030d => { Name => 'LevelMeter', Unknown => 1 }, # (guess)
+    0x0311 => 'Pitch', # Units??
+    0x0312 => 'Yaw',   # Units??
+    0x0313 => 'Roll',  # Units??
+    0x0314 => { Name => 'CX',   Unknown => 1 },
+    0x0315 => { Name => 'CY',   Unknown => 1 },
+    0x0316 => { Name => 'Rads', Unknown => 1 },
+);
+
 # Kodak SubIFD0 tags (ref PH)
 %Image::ExifTool::Kodak::SubIFD0 = (
@@ -846,5 +899,6 @@
         Name => 'SceneMode',
         Writable => 'int16u',
-        Notes => 'may not be valid for some models', # ie. M580?
+        Notes => 'may not be valid for some models', # eg. M580?
+        PrintConvColumns => 2,
         PrintConv => {
             1 => 'Sport',
@@ -867,6 +921,6 @@
             28 => 'Candlelight',
             29 => 'Sunset',
-            31 => 'Panorama Left-Right',
-            32 => 'Panorama Right-Left',
+            31 => 'Panorama Left-right',
+            32 => 'Panorama Right-left',
             33 => 'Smart Scene',
             34 => 'High ISO',
@@ -948,9 +1002,9 @@
     },
     0xfa57 => {
-        Name => 'PreviewWidth',
+        Name => 'PreviewImageWidth',
         Writable => 'int16u',
     },
     0xfa58 => {
-        Name => 'PreviewHeight',
+        Name => 'PreviewImageHeight',
         Writable => 'int16u',
     },
@@ -1008,4 +1062,5 @@
         Name => 'SceneModeUsed',
         Writable => 'int32u',
+        PrintConvColumns => 2,
         PrintConv => \%sceneModeUsed,
     },
@@ -1028,4 +1083,5 @@
         Name => 'SceneModeUsed',
         Writable => 'int32u',
+        PrintConvColumns => 2,
         PrintConv => \%sceneModeUsed,
     },
@@ -1297,15 +1353,19 @@
     },
     # 0x0000: int8u[4]    - values: "1 0 0 0" (DC50), "1 1 0 0" (DC120)
+    0x0000 => { #4
+        Name => 'KodakVersion',
+        Writable => 'int8u',
+        Count => 4,
+        PrintConv => '$val =~ tr/ /./; $val',
+        PrintConvInv => '$val =~ tr/./ /; $val',
+    },
     0x0001 => {
         # (related to EV but exact meaning unknown)
-        Name => 'UnknownEV',
+        Name => 'UnknownEV', # ("DeletedTag", ref 4)
         Writable => 'rational64u',
         Unknown => 1,
     },
     # 0x0002: int8u       - values: 0
-    0x0003 => {
-        Name => 'ExposureValue',
-        Writable => 'rational64u',
-    },
+    0x0003 => { Name => 'ExposureValue',    Writable => 'rational64u' },
     # 0x0004: rational64u - values: 2.875,3.375,3.625,4,4.125,7.25
     # 0x0005: int8u       - values: 0
@@ -1313,14 +1373,56 @@
     # 0x0007: int32u[3]   - values: "65536 67932 69256"
     0x03e9 => { Name => 'OriginalFileName', Writable => 'string' },
-    0x03eb => 'SensorLeftBorder',
-    0x03ec => 'SensorTopBorder',
-    0x03ed => 'SensorImageWidth',
-    0x03ee => 'SensorImageHeight',
+    0x03ea => { Name => 'KodakTag',         Writable => 'int32u' }, #4
+    0x03eb => { Name => 'SensorLeftBorder', Writable => 'int16u' }, # ("FinishedImageX", ref 4)
+    0x03ec => { Name => 'SensorTopBorder',  Writable => 'int16u' }, # ("FinishedImageY", ref 4)
+    0x03ed => { Name => 'SensorImageWidth', Writable => 'int16u' }, # ("FinishedImageWidth", ref 4)
+    0x03ee => { Name => 'SensorImageHeight',Writable => 'int16u' }, # ("FinishedImageHeight", ref 4)
+    0x03ef => { Name => 'BlackLevelTop',    Writable => 'int16u' }, #4
+    0x03f0 => { Name => 'BlackLevelBottom', Writable => 'int16u' }, #4
     0x03f1 => {
-        Name => 'TextualInfo',
+        Name => 'TextualInfo', # ("CameraSettingString", ref 4)
         SubDirectory => {
             TagTable => 'Image::ExifTool::Kodak::TextualInfo',
         },
     },
+    0x03f2 => { #IB/4
+        Name => 'FlashMode',
+        Writable => 'int16u',
+        Unknown => 1,
+        Priority => 0,
+    },
+    0x03f3 => { #IB/4
+        Name => 'FlashCompensation',
+        Writable => 'rational64s',
+    },
+    0x03f4 => { #4
+        Name => 'WindMode',
+        Writable => 'int16u',
+        Unknown => 1,
+    },
+    0x03f5 => { #4
+        Name => 'FocusMode',
+        Writable => 'int16u',
+        Unknown => 1,
+        Priority => 0,
+    },
+    0x03f8 => { #IB/4
+        Name => 'MinAperture',
+        Writable => 'rational64u',
+    },
+    0x03f9 => { #IB/4
+        Name => 'MaxAperture',
+        Writable => 'rational64u',
+    },
+    0x03fa => { #4
+        Name => 'WhiteBalanceMode',
+        Writable => 'int16u',
+        Unknown => 1,
+    },
+    0x03fb => { #4
+        Name => 'WhiteBalanceDetected',
+        Writable => 'int16u',
+        Unknown => 1,
+    },
     0x03fc => { #3
         Name => 'WhiteBalance',
@@ -1329,5 +1431,5 @@
         PrintConv => { },   # no values yet known
     },
-    0x03fd => { #3
+    0x03fd => [{ #3
         Name => 'Processing',
         Condition => '$count == 72',
